<template>
    <div class="item">
        <h1>File Upload</h1>
        <v-form>
            <v-file-input
                label="Upload Assets"
                v-model="upload"/>
            <v-text-field
                v-model="metadata.title"
                :error-messages="errors"
                label="Title"
                required
            ></v-text-field>
            <v-text-field
                v-model="metadata.author"
                :error-messages="errors"
                label="Author(s)"
                required
            ></v-text-field>
            <v-textarea
                name="input-7-1"
                label="Description"
                v-model="metadata.description"
                hint="Hint text"
            ></v-textarea>
            <v-textarea
                name="input-7-1"
                label="Abstract"
                v-model="metadata.abstract"
                hint="Hint text"
            ></v-textarea>

            <input type="submit" @click="save" />
        </v-form>
    </div>
</template>

<script>
import OrbitDB from 'orbit-db'
import IPFS from 'ipfs'

export default {
    name: 'item',
    props: ['state'],
    data: function() {
        return {
            upload: null,
            file: {
                hash: ''
            },
            metadata: {
                title: null,
                description: null,
                abstract: null,
                authors: null
            }
        }
    },
    methods: {
        save(event) {
            event.preventDefault()
            const reader = new FileReader()
            reader.readAsArrayBuffer(this.upload)

            reader.onloadend = async () => {
                const nodeId = await this.state.ipfs.id()
                console.log('ipfs id', nodeId.addresses)
                const response = await this.state.ipfs.add(IPFS.Buffer(reader.result))
                this.file = response[0]

                console.log('ipfs hash', this.file.hash)

                // let's create a small db per asset so it is super-portable...
                const keyvalueDbName = this.file.hash+'.metadata'
                const orbitdb = await OrbitDB.createInstance(this.state.ipfs)
                const keyvalueDb = await orbitdb.keyvalue(keyvalueDbName)
                await keyvalueDb.load()

                for (const key of Object.keys(this.metadata)) {
                    if (this.metadata[key]) {
                        await keyvalueDb.set(key, this.metadata[key])
                    }
                }

                const archiveDbName = this.state.owner+'.archive'
                const archiveDb = await orbitdb.log(archiveDbName)
                await archiveDb.load()

                await archiveDb.add(this.file.hash)

                const topic = "knowledgearc-network-ipfs"
                const msg = IPFS.Buffer.from(this.file.hash)

                await this.state.ipfs.pubsub.publish(topic, msg)

                console.log(`published to ${topic}`)
            }
        }
    }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h1,
h2 {
    font-weight: normal;
    display: block;
}

ul {
    list-style-type: none;
    padding: 0;
}

li {
    display: inline-block;
    margin: 0 10px;
}

a {
    color: #42b983;
}

ul {
    display: grid;
}
</style>
